*
* (c) jonathan hudson 1995,1996
*
VERS		equ	'1.22'

sms.lthg	equ	$26
sms.uthg	equ	$28
sms.fthg	equ	$29
sms.zthg	equ	$2a
sms.nthg	equ	$2b
sms.nthu	equ	$2c

sms.info	equ	$00
sms.ssjb	equ	$08
sms.achp	equ	$18
sms.rchp	equ	$19

mem.achp	equ	$c0
mem.rchp	equ	$c2
mem.rlst	equ	$d4

sys_thgl	equ	$b8

th_thing	equ	$10
th_name		equ	$2a

thh_type	equ	$04
thh_entr	equ	$08

err.nimp	equ	-19
err.fdiu	equ	-9
err.itnf	equ	-7

bv.rip		equ	$58

qa.resri	equ	$11a
sb.inipr	equ	$110
sb.gtint	equ	$112
sb.gtfp		equ	$114
sb.gtstr	equ	$116
sb.gtlin	equ	$118
sb.putp		equ	$120

ioa.open	equ	$01
ioa.clos	equ	$02

iob.smul	equ	$07
iob.fmul	equ	$03

hdr.flg		equ	$00
hdr.job		equ	$04
hdr.chi		equ	$08
hdr.cho		equ	$0c
hdr.nam		equ	$10
hdr.len		equ	$12

ut.wtext	equ	$d0

wstrg$	macro	a
[.lab]	dc.w	.e.[.l]-*-2
	dc.b	[a]
.e.[.l]	equ	*
	ds.w	0
	endm

bstrg$	macro	a
[.lab]	dc.b	.e.[.l]-*-1
	dc.b	[a]
.e.[.l]	equ	*
	endm
		
	section Thingy

	lea.l	cprocs,a0	
	lea.l	creq,a1
	move.l	a1,(a0)
	lea.l	cpoll,a1
	move.l	a1,4(a0)
	lea.l	lpoll,a1
	move.l	a1,8(a0)
	lea.l	sbro,a1
	move.l	a1,12(a0)
	lea.l	spend,a1
*	VERSION is at 16(a0)
	move.l	a1,20(a0)

	lea.l	cmsg,a1
	move.l	#0,a0
	move.w	ut.wtext,a2
	jsr	(a2)
	
	bsr	getthg				; thing system
	beq.s	done2				; no ...
	move.l	d0,a5				; save vector

	moveq	#sms.zthg,d0			; zap old instance
	lea.l	thgname,a0			; of this this
	jsr	(a5)				; ... bye

	move.l	#$3a,d1				; we need
	bsr.s	alchp0				; some memory
	bne.s	done1				; OK ?
	move.l	a0,a1				; save it

	lea.l	th_thing(a1),a2			; thing start
	lea.l	hc0thg,a3			; first (new) thing
	move.l	a3,(a2)+			; save start
	lea.l	muse,a3				; custom useage
	move.l	a3,(a2)+			; save it
	lea.l	mfree,a3			; custom free
	move.l	a3,(a2)+			; save it
	lea.l	mffree,a3			; custom ffree
	move.l	a3,(a2)+			; save it
	move.l	#0,(a2)+			; default remove
	clr.w	(a2)+				; shareable
	move.l	#VERS,(a2)+			; version No
	lea.l	thgname,a3			; name
	move.w	(a3)+,d1			; length
	move.w	d1,(a2)+			; save it
	bra.s	lt.01				; loop
lt.00
	move.b	(a3)+,(a2)+			; copy bytes
lt.01
	dbra	d1,lt.00			
	moveq	#sms.lthg,d0			; link flag
	jsr	(a5)				; jump to it
	tst.l	d0				; OK
	bne.s	done1				; .. no ???

	lea.l	table(pc),a1			; extensions
	move.w	sb.inipr,a2			; link in
	jsr	(a2)				; and go
	bra.s	done1
done2:
	moveq	#err.nimp,d0
done1:
	rts
alchp0:
	moveq	#0,d2
alchp
	movem.l	a1-a3/d3,-(sp)
	moveq	#sms.achp,d0
	trap	#1
	movem.l	(sp)+,a1-a3/d3	
	tst.l	d0
	rts

strneq
	movem.l	a0-a1/d1-d2,-(sp)
	move.w	(a0)+,d2
	move.w	(a1)+,d1
	cmp.w	d1,d2
	bne.s	st.01
	bra.s	st.10
st.00	
	move.b	(a0)+,d0
	move.b	(a1)+,d1
	ori.b	#' ',d0
	ori.b	#' ',d1
	cmp.b	d0,d1
	bne.s	st.01
st.10	dbra	d2,st.00
	moveq	#0,d0
	bra.s	st.02
st.01	moveq	#-1,d0
st.02
	movem.l	(sp)+,a0-a1/d1-d2
	rts

doCLNT:
	move.l	#'SRVR',d2
	moveq	#0,d7				; check id flag = 0
	bsr.s	CheckName
	tst.l	d0
	beq.s	dc.1
	moveq	#1,d7				; check id flag = 0
	move.l	#'CLNT',d2
	bsr.s	CheckName
	tst.l	d0
	bne.s	dc.3
	moveq	#$20+hdr.len,d1
	add.w	(a3),d1
	bra.s	dc.2
dc.3
	moveq	#err.fdiu,d2
	bra.s	dc.4
dc.1
	moveq	#err.itnf,d2
dc.4	moveq	#$24,d1
dc.2
	rts

CheckName:

*	a3 = name we want
*	d2 = type we want
*	d7 = additional check
*	a5 = thing vector

	movem.l	a0-a3/d2-d6,-(sp)		; Save Linkage !
	move.l	d2,d6
	lea.l	thgname,a0
	suba.l	a1,a1
cs.1
	moveq	#sms.nthu,d0
	jsr	(a5)	
	cmp.l	#0,a1				; end
	beq.s	cs.8				; yes
	tst.l	d0
	bne.s	cs.8				; yes
	cmp.l	$10(a1),d6			; type
	beq.s	cs.11
	cmpi.l	#'CLNT',d6			; could be LSTN
	bne.s	cs.1				; no, continue
	cmpi.l	#'LSTN',$10(a1)			; this matches too
	bne.s	cs.1
cs.11	tst.w	d7				; check job ID
	beq.s	cs.6				; no
	cmp.l	$10+hdr.job(a1),d1		; Job ID OK ?
	bne.s	cs.1				; no
cs.6
	move.l	a1,-(sp)
	exg	a3,a0
	lea.l	$10+hdr.nam(a1),a1		; name
	bsr	strneq
	exg	a0,a3
	move.l	(sp)+,a1			; restore a1
	tst.l	d0				; result ?
	bne	cs.1				; not equal
	moveq	#err.fdiu,d0			; Oh dear
	bra.s	cs.9				; return error
cs.8
	moveq	#0,d0			; OK
cs.9
	move.l	a1,a4
	movem.l	(sp)+,a0-a3/d2-d6
	rts

doSRVR:
	moveq	#0,d7				; check id flag = 0
	bsr.s	CheckName
	tst.l	d0
	bne.s	sd.1
	moveq	#$20+hdr.len,d1
	add.w	(a3),d1
	bra.s	sd.2
sd.1
	moveq	#$24,d1
	moveq	#err.fdiu,d2
sd.2	rts


stName
	move.l	a3,-(sp)
	move.w	(a3)+,d0
	move.w	d0,(a4)+
	bra.s	sts.1
sts.2	move.b	(a3)+,(a4)+
sts.1	dbra	d0,sts.2
	move.l	(sp)+,a3
	moveq	#0,d0
	rts

muse:
	movem.l	a3-a4,-(sp)
	move.l	d3,a3
	moveq	#0,d3
	move.l	d1,-(sp)	
	bsr	getthg
	move.l	d0,a5
	move.l	d2,d5
	cmp.l	#'CLNT',d2
	beq.s	m33
	cmp.l	#'LSTN',d2
	bne.s	m1
m33
	bsr	doCLNT
	bra.s	m9
m1
	cmp.l	#'SRVR',d2
	bne.s	m2
	bsr.s	doSRVR
	bra.s	m9
m2
	moveq	#err.nimp,d0	
	moveq	#$24,d1
m9
	movem.l	a1-a3/d2-d3,-(sp)
	move.w	mem.achp,a0
	jsr	(a0)
	movem.l	(sp)+,a1-a3/d2-d3
	move.l	(sp)+,d1
	tst.l	d0
	bne.s	m99
	cmp.l	#'SRVR',d2
	beq.s	m11
	cmp.l	#'CLNT',d2
	bne.s	m99
m11
	lea.l	$20+hdr.nam(a0),a4
	bsr	stName
	move.l	d1,$20+hdr.job(a0)		; jobID
m99
	move.l	d5,$20(a0)
	tst.l	d2
	blt.s	m101
	move.l	a0,a4
	bsr	OpenPipes
	bra.s	m100
m101
	move.l	d2,d0
m100	
	move.l	a0,d2
	add.l	#$10,d2
	movem.l	(sp)+,a3-a4
	tst.l	d0
	rts	

mfree
	movem.l	a3-a4,-(sp)
	move.l	d3,a3

	moveq	#0,d3
	moveq	#1,d7				; check id flag = 1
	move.l	d1,-(sp)	
	bsr	getthg
	move.l	d0,a5
	cmp.l	#'CLNT',d2
	beq.s	f.10
	cmp.l	#'LSTN',d2
	bne.s	f.1
f.10
	bsr	CheckName
	tst.l	d0
	beq.s	f.4
	bra.s	f.3
f.1
	cmp.l	#'SRVR',d2
	bne.s	f.2
	bsr	CheckName
	tst.l	d0
	beq.s	f.4
	bsr	CheckClients
f.3
	bsr	ClosePipes
	lea.l	-16(a4),a0	
f.2
	movem.l	a0-a2/d2-d3,-(sp)
	move.w	mem.rchp,a2
	jsr	(a2)
	movem.l	(sp)+,a0-a2/d2-d3
	bra.s	f.5
f.4
	moveq	#err.itnf,d0
	move.l	#0,a0
f.5
	move.l	(sp)+,d1
	movem.l	(sp)+,a3-a4
	rts

mffree
	lea.l	$10(a0),a4
	cmp.l	#'SRVR',$20+hdr.flg(a0)
	bne.s	ff.2
	bsr	getthg
	move.l	d0,a5
	lea.l	$20+hdr.nam(a0),a3
	bsr	CheckClients
	bra.s	ff.3
ff.2
	cmp.l	#'CLNT',$20+hdr.flg(a0)
	beq.s	ff.3
	cmp.l	#'LSTN',$20+hdr.flg(a0)	
	bne.s	ff.4
ff.3
	bsr.s	ClosePipes
	move.l	a0,-(sp)
	move.w	mem.rchp,a2
	jsr	(a2)
	move.l	(sp)+,a0
	bra.s	ff.5
ff.4
	moveq	#err.itnf,d0
	move.l	#0,a0
ff.5
	rts

getopipe:
	cmp.l	#$DEADBEEF,-32(a3)
	bne.s	gop.00
	cmp.l	#$FEEDFACE,-4(a3)
	bne.s	gop.00
	lea.l	-28(a3),a0
	bra.s	gop.01
gop.00
	lea.l	opipe,a0
gop.01	
	rts

OpenPipes
	movem.l	a0-a2/d3,-(sp)
	moveq	#0,d3
	bsr	getopipe
	lea.l	$20+hdr.cho(a4),a2
	bsr.s	openchn
	move.l	a0,d3
	lea.l	ipipe,a0
	lea.l	$20+hdr.chi(a4),a2
	bsr.s	openchn
	movem.l	(sp)+,a0-a2/d3	
	rts
	
ClosePipes
	movem.l	a0-a1,-(sp)
	move.l	$10+hdr.cho(a4),a0
	move.l	#-1,$10+hdr.cho(a4)
	cmp.l	#0,a0
	ble.s	cp.1		
	moveq	#ioa.clos,d0
	trap	#2
cp.1
	move.l	$10+hdr.chi(a4),a0
	move.l	#-1,$10+hdr.chi(a4)
	cmp.l	#0,a0
	ble.s	cp.2		
	moveq	#ioa.clos,d0
	trap	#2
cp.2	
	movem.l	(sp)+,a0-a1	
	rts

openchn
	moveq	#ioa.open,d0
	trap	#2
	tst.l	d0
	bne.s	op.1
	move.l	a0,(a2)
op.1
	rts	

CheckClients:
	movem.l	a0-a2/a4,-(sp)		; Save Linkage !
	suba.l	a1,a1
	lea.l	thgname,a0
cc.1
	moveq	#sms.nthu,d0
	jsr	(a5)
	cmp.l	#0,a1				; end
	beq.s	cc.9				; yes
	move.l	a1,a4
	cmp.l	#'CLNT',$10(a4)			; type
	beq.s	cc.11
	cmp.l	#'LSTN',$10(a4)			; type
	bne.s	cc.1				; no, continue
cc.11
	movem.l	a0-a1,-(sp)
	move.l	a3,a0				; SRVR Name
	lea.l	$10+hdr.nam(a4),a1		; name	
	bsr	strneq
	movem.l	(sp)+,a0-a1
	tst.l	d0				; result ?
	bne.s	cc.1				; not equal
	bsr	ClosePipes			; by bye
	bra.s	cc.1
cc.9
	movem.l	(sp)+,a0-a2/a4
	rts

table:
	dc.w	14
* --- Real procedures
	dc.w	freeclient-*
	bstrg$	{'FREECLIENT'}
	dc.w	freeServer-*
	bstrg$	{'FREESERVER'}
	dc.w	Freelstr-*
	bstrg$	{'FREELSTN'}

* --- The 'old' procdures
	dc.w	client-*	
	bstrg$	{'CLIENT'}
	dc.w	server-*
	bstrg$	{'SERVER'}
	dc.w	Request-*
	bstrg$	{'REQUEST'}
	dc.w	SrvReply-*
	bstrg$	{'SRVREPLY'}
	dc.w	listner-*
	bstrg$	{'LISTENER'}
	dc.w	srvrbro-*
	bstrg$	{'SRVRBRO'}
	dc.w	0
	dc.w	20
* ---- old (fp) functions
	dc.w	SrvPoll-*
	bstrg$	{'SRVPOLL'}
	dc.w	LstPoll-*
	bstrg$	{'LSTNPOLL'}
* ---- old (int) functions
	dc.w	FindSrvr-*
	bstrg$	{'FINDSERVER'}
	dc.w	SrvPend-*
	bstrg$	{'SRVPEND'}
* ---- New int functions
	dc.w	clientF-*
	bstrg$	{'CLIENT%'}
	dc.w	serverF-*
	bstrg$	{'SERVER%'}
	dc.w	RequestF-*
	bstrg$	{'REQUEST%'}
	dc.w	SrvReplyF-*
	bstrg$	{'SRVREPLY%'}
	dc.w	listnerF-*
	bstrg$	{'LISTENER%'}
	dc.w	srvrbroF-*
	bstrg$	{'SRVRBRO%'}
	dc.w	FindSrvrF-*
	bstrg$	{'FINDSERVER%'}
	dc.w	SrvPendF-*
	bstrg$	{'SRVPEND%'}
	dc.w	0

clientF:
	bsr	client
	bra.s	FINT
serverF:
	bsr	server
	bra.s	FINT
requestF:
	bsr	request
	bra.s	FINT
listnerF
	bsr	listner
	bra.s	FINT
srvreplyF:
	bsr	srvreply
	bra.s	FINT
srvrbroF:
	bsr	srvrbro
	bra.s	FINT
FindSrvrF:
	bsr	Find__Srvr	
	bra.s	FINT
SrvPendF:
	bsr	Srv__Pend
	bra.s	FINT

FindSrvr:
	bsr	Find__Srvr
	cmp.l	#0,d0
	bne.s	f00.00
	bra.s	f00.01

SrvPend:
	bsr	Srv__Pend
	cmp.l	#-1,d0
	beq.s	f00.00
	cmp.l	#0,d0
	bne.s	FINT
f00.01
	moveq	#1,d0
	bra.s	FINT
f00.00
	moveq	#0,d0
FINT:
	move.w	d0,d4
	moveq	#2,d1
	move.w	qa.resri,a2
	jsr	(a2)
	move.l	bv.rip(a6),a1
	subq.l	#2,a1
	move.l	a1,bv.rip(a6)
	move.w	d4,0(a6,a1.l)
	moveq	#3,d4
	moveq	#0,d0
	rts


FreeServer
	move.l	#'SRVR',d7
	bra.s	fcsrv

FreeClient
	move.l	#'CLNT',d7	
	bra.s	fcsrv
FreeLstr
	move.l	#'LSTN',d7	
fcsrv
	bsr.s	Setup
	tst.l	d0
	bne.s	fcs.01
	move.l	a2,d3	
	moveq	#sms.fthg,d0
	lea.l	-32(a2),a3
	move.l	a3,-(sp)
	jsr	(a5)
	move.l	(sp)+,a0
	moveq	#sms.rchp,d0
	trap	#1	
	moveq	#0,d0
fcs.01
	rts
Setup
	move.l	a5,a2
	sub.l	a3,a2
	move.l	a2,d1
	cmp.l	#8,d1
	blt	su.02
	cmp.l	#16,d1
	bne.s	nsp.0			      ; old, one parameter
	move.l	a3,-(sp)
	lea.l	8(a3),a3
	move.w	sb.gtlin,a2
	jsr	(a2)
	move.l	(sp)+,a3
	tst.l	d0
	bne.s	nsp.0
	move.l	0(a6,a1.l),d5			; d5 is our size
	add.l	#4,bv.rip(a6)
	bra.s	nsp.1
nsp.0
	moveq	#0,d5
nsp.1		
	lea.l	8(a3),a5
	move.w	sb.gtstr,a2
	jsr	(a2)
	tst.l	d0
	bne	su.02
su.00
	bsr	getthg
	beq	su.03
	move.l	d0,a5

**	0(a6,a1.l) = name
**	 d5 = size or 0

	moveq	#-1,d2
	clr.l	d1
	move.w	0(a6,a1.l),d1
	add.l	#32,d1
	bsr	alchp
	bne.s	su.01
	move.l	a0,a2
	cmp.l	#0,d5
	beq.s	nsp.05
	move.l	#$deadbeef,(a0)
	move.l	#'pipe',6(a0)
	move.b	#'_',10(a0)
	move.l	d5,d1
	lea.l	11(a0),a0
	bsr	writen
	add.w	#5,d1
	move.w	d1,4(a2)
	move.l	#$feedface,28(a2)
	bra.s	nsp.06
nsp.05
	move.l	#0,0(a2)
	move.l	#0,28(a2)
nsp.06
	lea.l	32(a2),a2
	move.l	a2,a0
	move.w	0(a6,a1.l),d1
	move.w	d1,(a0)+
	bra.s	nsp.04
nsp.03	move.b	2(a6,a1.l),(a0)+
	adda.l	#1,a1
nsp.04	dbra	d1,nsp.03
	lea.l	thgname,a0
	move.l	d7,d2
	moveq	#-1,d1
	moveq	#0,d0
	bra.s	su.01
su.02	moveq	#-15,d0
	bra.s	su.01
su.03	moveq	#err.nimp,d0	
su.01	rts

Server:
	move.l	#'SRVR',d7
	bra.s	ucsrv
Listner 
	move.l	#'LSTN',d7
	bra.s	ucsrv
Client:
	move.l	#'CLNT',d7	
ucsrv
	bsr	Setup
	tst.l	d0
	bne.s	ucs.01
	cmp.l	#'SRVR',d7
	beq.s	ucs.02
	movem.l	a2-a3,-(sp)
	move.l	a2,a3			; name
	moveq	#1,d7			; check type
	movem.l	a0/d2,-(sp)
	moveq	#sms.info,d0		; get system variables
	trap	#1
	movem.l	(sp)+,a0/d2
	trap	#0
	bsr	CheckName
	andi.w	#$d8ff,sr
	movem.l	(sp)+,a2-a3
	tst.l	d0
	beq.s	ucs.02
	moveq	#0,d0
	bra.s	ucs.01
ucs.02:
	moveq	#sms.uthg,d0
	move.l	a2,d3	
	lea.l	-32(a2),a3
	move.l	a3,-(sp)
	jsr	(a5)
	move.l	(sp)+,a0
	move.l	d0,-(sp)
	moveq	#$19,d0
	trap	#1	
	move.l	(sp)+,d0
	tst.l	d0
ucs.01
	rts

getthg:
	movem.l	a0/a2/d2,-(sp)
	moveq	#sms.info,d0		; get system variables
	trap	#1
	move.l	sys_thgl(a0),d2		; this is the thing list
	beq.s	thg_nf			; empty list, very bad!
	move.l	d2,a0
thg_lp:
	move.l	(a0),d2			; get next list entry
	beq.s	thg_found		; end of list? here should be thing!
	move.l	d2,a0			; next link
	bra.s	thg_lp
thg_found:
	move.l	th_thing(a0),a0		; get start of thing
	move.l	thh_type(a0),d2		; is it our special thing?
	addq.l	#1,d2
	bne.s	thg_nf			; sorry, it isnt
	move.l	thh_entr(a0),d0		; this is the vector we look for
	bra.s	thg_rts
thg_nf:
	moveq	#0,d0		 ; no thing
thg_rts:
	movem.l	(sp)+,a0/a2/d2
	tst.l	d0
	rts

hc0thg:
	dc.l	'THG%'
	dc.l	$01000003
	dc.l	hc1thg-hc0thg
	dc.l	'SRVR'
	dc.l	0
	dc.l	0
prev
	lea.l	cprocs,a0
	move.l	a0,d0
	rts

hc1thg:
	dc.l	'THG%'
	dc.l	$01000003
	dc.l	hc2thg-hc1thg
	dc.l	'CLNT'
	dc.l	0
	dc.l	0
	bra.s	prev
	rts
hc2thg:
	dc.l	'THG%'
	dc.l	$01000003
	dc.l	0
	dc.l	'LSTN'
	dc.l	0
	dc.l	0
	bra.s	prev
	rts

Srv__Pend
	move.w	sb.gtstr,a2
	jsr	(a2)
	tst.l	d0
	rts
	cmp.w	#1,d3
	bne	fs.05
	move.l	a1,a3				; This is the first
	clr.l	d1
	move.w	0(a6,a3.l),d1			; size
	addq.w	#3,d1
	bclr	#0,d1				; get even
	add.l	d1,bv.rip(a6)			; sort out maths stack
	move.l	#'SRVR',d2
	move.l	a3,d6
	moveq	#0,d7				; check id flag = 0
	bsr	getthg
	beq.s	fs.07
	move.l	a5,a0
	move.l	d0,a5
	trap	#0
	lea.l	0(a6,a3.l),a3
	bsr	CheckName
	andi.w	#$d8ff,sr
	tst.l	d0
	beq.s	fs.07
	move.l	$10+hdr.chi(a4),a0
	moveq	#0,d0				; io.pend
	moveq	#0,d3
	trap	#3
	rts

fs.07	moveq	#err.itnf,d0
FRTS	rts

Find__Srvr
	move.w	sb.gtstr,a2
	jsr	(a2)
	tst.l	d0
	bne.s	FRTS
	cmp.w	#1,d3
	bne.s	fs.05
	move.l	a1,a3				; This is the first
	clr.l	d1
	move.w	0(a6,a3.l),d1			; size
	addq.w	#3,d1
	bclr	#0,d1				; get even
	add.l	d1,bv.rip(a6)			; sort out maths stack
	move.l	#'SRVR',d2
	move.l	a3,d6
	moveq	#0,d7				; check id flag = 0
	bsr	getthg
	beq.s	fs.03
	move.l	a5,a0
	move.l	d0,a5
	trap	#0
	lea.l	0(a6,a3.l),a3
	bsr	CheckName
	andi.w	#$d8ff,sr
	tst.l	d0
	beq.s	fs.08
	moveq  #0,d0
fs.03
	rts
fs.05
	moveq	#-15,d0
	rts
fs.08	moveq	#-7,d0
	rts

Request
	move.l	a5,a2
	sub.l	a3,a2
	move.l	a2,d1
	cmp.l	#16,d1
	bne.s	rx.01
	move.l	#0,d5
	bra.s	rx.00
rx.01
	cmp.l	#24,d1
	bne	rq.01
	lea.l	-8(a5),a5
	move.l	a5,d5
rx.00
	move.w	sb.gtstr,a2
	jsr	(a2)
	tst.l	d0
	bne	rq.01
	cmp.w	#2,d3
	bne	rq.01
	move.l	a1,a3				; This is the first
	clr.l	d1

	move.w	0(a6,a3.l),d1			; size
	addq.w	#3,d1
	bclr	#0,d1				; get even
	lea.l	0(a1,d1.w),a1			; next paramter
	move.l	a1,a5				; command
	add.w	0(a6,a5.l),d1
	addq.w	#3,d1
	bclr	#0,d1
	add.l	d1,bv.rip(a6)			; sort out maths stack
	move.l	#'SRVR',d2
	move.l	a3,d6
	moveq	#0,d7				; check id flag = 0
	bsr	getthg
	beq	rq.03
	move.l	a5,a0
	move.l	d0,a5
	trap	#0
	lea.l	0(a6,a3.l),a3
	bsr	CheckName
	andi.w	#$d8ff,sr
	tst.l	d0
	beq	rq.03
	move.l	a4,-(sp)
	move.l	#'CLNT',d2
	moveq	#1,d7				; check id flag = 1
	trap	#0
	lea.l	0(a6,d6.l),a3
	bsr	CheckName
	andi.w	#$d8ff,sr
	move.l	(sp)+,a2
	tst.l	d0
	beq	rq.04
	move.l	a0,a5
	moveq	#-1,d2				; this job
	moveq	#6,d1				; six bytes
	add.w	0(a6,a5.l),d1			; plus buffer
	move.l	a2,-(sp)			; save pointer
	moveq	#sms.achp,d0			; get heap	
	trap	#1				; action
	move.l	(sp)+,a2			; restore it
	tst.l	d0				; got it
	bne	rq.02				; No
	move.l	a0,a1				; save pointer
	move.l	a1,-(sp)			; again
	move.l	$10+hdr.cho(a2),a0		; Server channel
	cmp.l	#0,d5
	bne.s	rx.03
	move.l	#0,(a1)
	bra.s	rx.04
rx.03
	move.l	$10+hdr.cho(a4),(a1)		; My channel for reply
rx.04
	move.w	0(a6,a5.l),d1			; len
	move.w	d1,4(a1)			; info len
	move.w	d1,d2
	add.w	#6,d2
	moveq	#-1,d3				; time out
	moveq	#iob.smul,d0			; action
	lea.l	6(a1),a3			; we are here
	bra.s	rq.21
rq.22
	move.b	2(a6,a5.l),(a3)+		; copy bytes
	add.l	#1,a5
rq.21
	dbra	d1,rq.22
	trap	#3				; now do it
	move.l	(sp),a0				; buffer
	move.l	d0,(sp)				; we still own it :-)
	moveq	#sms.rchp,d0			; free
	trap	#1				; do it
	move.l	(sp)+,d0			; i/o result
	tst.l	d0
	bne.s	rq.02
	cmp.l	#0,d5
	beq.s	rq.02
	moveq	#2,d2
	tst.w	-(sp)				; make space
	move.l	sp,a1				; buffer
	move.l	$10+hdr.chi(a4),a0		; my channel
	moveq	#iob.fmul,d0			; a read
	moveq	#-1,d3
	trap	#3
	clr.l	d1
	move.w	(sp)+,d1			; bytes in reply
	tst.l	d0
	bne.s	rq.02
	move.w	d1,d4				; save bytes needed
	add.w	#3,d1
	bclr	#0,d1
	move.l	d1,d7	
	move.w	qa.resri,a3
	jsr	(a3)
	move.l	bv.rip(a6),a1
	move.l	a1,a5
	sub.l	d7,a1
	move.l	a1,bv.rip(a6)
	move.w	d4,0(a6,a1.l)
	move.w	d4,d2
	beq.s	rq.20				; none !!!
	add.l	#2,a1
	moveq	#-1,d3
	trap	#4
	moveq	#iob.fmul,d0
	trap	#3
	tst.l	d0
	bne.s	rq.02
rq.20
	move.l	d5,a3
	move.w	$120,a2
	jsr	(a2)
	move.l	a5,bv.rip(a6)
	bra.s	rq.02	
rq.01
	moveq	#-15,d0
	bra.s	rq.02
rq.03
	moveq	#-7,d0
	bra.s	rq.02
rq.04
	moveq	#-6,d0
	bra.s	rq.02
rq.05	
	moveq	#-3,d0	
rq.09
rq.02		
	rts

lstpoll
	move.l	#'LSTN',d7
	bra.s	poller
srvpoll
	move.l	#'SRVR',d7
poller
	move.l	a5,a2
	sub.l	a3,a2
	move.l	a2,d1
	cmp.l	#16,d1
	blt	rq.01
	cmp.l	#24,d1
	bne.s	sp.0
	move.l	a3,-(sp)
	lea.l	16(a3),a3
	move.w	sb.gtlin,a2
	jsr	(a2)
	move.l	(sp)+,a3
	tst.l	d0
	bne.s	sp.0
	move.l	0(a6,a1.l),d6
	add.l	#4,bv.rip(a6)
	bra.s	sp.1
sp.0
	moveq	#-1,d6
sp.1		
	lea.l	8(a3),a5
	move.l	a5,d5
	move.w	sb.gtstr,a2
	move.l	d6,-(sp)			; smashes d6 !!!
	jsr	(a2)
	move.l	(sp)+,d6
	tst.l	d0
	bne	rq.01
	cmp.w	#1,d3
	bne	rq.01
	move.l	a1,a3				; This is the first
	clr.l	d1
	move.w	0(a6,a3.l),d1			; size
	addq.w	#3,d1
	bclr	#0,d1				; get even
	add.l	d1,bv.rip(a6)			; sort out maths stack
	bsr	getthg
	move.l	d0,a5
	move.l	d7,d2
	moveq	#0,d7				; check id flag = 0
	trap	#0
	lea.l	0(a6,a3.l),a3
	bsr	CheckName
	andi.w	#$d8ff,sr
	tst.l	d0
	beq	rq.04
	move.l	$10+hdr.chi(a4),a0
	sub.l	#6,a7
	move.l	a7,a1
	moveq	#6,d2
	move.w	d6,d3
	moveq	#iob.fmul,d0
	trap	#3
	clr.l	d1
	move.l	(sp)+,d7			; Return channel
	move.w	(sp)+,d1			; packet size
	tst.l	d0
	bne.s	sq.2
	
	move.w	d1,d4				; save bytes needed
	add.w	#3,d1
	bclr	#0,d1
	move.l	d1,a4	
	move.w	qa.resri,a3
	jsr	(a3)
	move.l	bv.rip(a6),a1
	move.l	a1,a5
	sub.l	a4,a1
	move.l	a1,bv.rip(a6)
	move.w	d4,0(a6,a1.l)
	move.w	d4,d2
	beq.s	sq.20				; none !!!
	add.l	#2,a1
	moveq	#-1,d3
	trap	#4
	moveq	#iob.fmul,d0
	trap	#3
	tst.l	d0
	bne	rq.02
sq.20
	move.l	d5,a3
	move.w	$120,a2
	jsr	(a2)
	move.l	a5,bv.rip(a6)
	move.l	d7,d0
sq.2
	move.w	d0,d4
	move.l	d0,d5
	beq.s	sq.5
	move.w	#2079,d4
	add.l	d0,d0
	bvs.s	sq.5
	subq.w	#1,d4
	move.l	d0,d5
	moveq	#16,d1
sq.3
	move.l	d5,d0
	asl.l	d1,d0
	bvs.s	sq.4
	sub.w	d1,d4
	move.l	d0,d5
sq.4
	asr.w	#1,d1
	bne.s	sq.3
sq.5
	moveq	#6,d1
	move.w	qa.resri,a2
	jsr	(a2)
	move.l	bv.rip(a6),a1
	subq.l	#6,a1
	move.l	a1,bv.rip(a6)
	move.w	d4,0(a6,a1.l)
	move.l	d5,2(a6,a1.l)
	moveq	#2,d4
	moveq	#0,d0
	rts

SrvReply
	lea.l	8(a3),a5
	move.w	sb.gtlin,a2
	jsr	(a2)
	tst.l	d0
	bne	rq.01
	cmp.w	#1,d3
	bne	rq.01
	move.l	0(a6,a1.l),d6			; channel
	add.l	#4,bv.rip(a6)
	move.l	a5,a3
	lea.l	8(a3),a5
	move.w	sb.gtstr,a2
	jsr	(a2)
	tst.l	d0
	bne	rq.01
	cmp.w	#1,d3
	bne	rq.01
	move.l	d6,a0				; reply channel
	move.l	a1,a4				; save pointer
	moveq	#2,d2				; two bytes
	moveq	#-1,d3				; timeout
	trap	#4
	moveq	#iob.smul,d0			; action
	trap	#3				; send it
	tst.l	d0				
	bne.s	sr.01
	move.l	a4,a1				; pointer
	move.w	0(a6,a1.l),d2
	addq.l	#2,a1				; to actual data
	trap	#4				; relative to basic
	moveq	#iob.smul,d0
	trap	#3 
sr.01	
	rts

SrvrBro
	move.w	sb.gtstr,a2
	jsr	(a2)
	tst.l	d0
	bne	rq.01
	cmp.w	#2,d3
	bne	rq.01
	move.l	a1,a3				; This is the first
	clr.l	d1
	move.w	0(a6,a3.l),d1			; size
	addq.w	#3,d1
	bclr	#0,d1				; get even
	lea.l	0(a1,d1.w),a1			; next paramter
	move.l	a1,a5				; command
	add.w	0(a6,a5.l),d1
	addq.w	#3,d1
	bclr	#0,d1
	add.l	d1,bv.rip(a6)			; sort out maths stack

***	a6,a3	is name
***	a6,a5	is string
	moveq	#-1,d2
	bsr	alchp
	bne.s	lp.99
	move.l	a0,-(sp)
	move.w	0(a6,a3.l),d1
	move.w	d1,(a0)+
	bra.s	lp.03	
lp.02	move.b	2(a6,a3.l),(a0)+
	add.l	#1,a3
lp.03
	dbra	d1,lp.02		
	move.l	(sp)+,a3
	move.l	a0,d0
	add.l	#1,d0
	andi.l	#$fffffffe,d0
	move.l	d0,a0
lp.04
	move.l	a0,-(sp)

	move.w	0(a6,a5.l),d1
	move.w	d1,(a0)+
	bra.s	lp.06	
lp.05	move.b	2(a6,a5.l),(a0)+
	add.l	#1,a5
lp.06
	dbra	d1,lp.05		
	move.l	(sp)+,a4
	bsr.s	SendMsg
	moveq	#sms.rchp,d0
	move.l	a3,a0
	trap	#1
	moveq	#0,d0
lp.99
	rts

SendMsg
*	a3 = name
*	a4 = msg
	move.l	a3,-(sp)
	bsr	getthg				; get thing
	beq.s	ms.8				; fails
	move.l	d0,a5				; thing vector
	suba.l	a1,a1				; zero a1
ms.1
	lea.l	thgname,a0			; thing name
	moveq	#sms.nthu,d0			; next users
	jsr	(a5)				; find one
	cmp.l	#0,a1				; end
	beq.s	ms.8				; yes
	tst.l	d0				; check
	bne.s	ms.8				; yes
	cmpi.l	#'LSTN',$10(a1)			; this matches too
	bne.s	ms.1				; a listener
	move.l	a1,-(sp)			; save usage
	move.l	a3,a0				; a3 is name
	lea.l	$10+hdr.nam(a1),a1		; name
	bsr	strneq				; check name
	move.l	(sp)+,a1			; restore a1
	tst.l	d0				; result ?
	bne	ms.1				; not equal
	move.l	a1,-(sp)			; usage
	move.l	$10+hdr.cho(a1),a0		; channel to write
	sub.l	#6,a7				; use stack
	move.l	a7,a1				; buffer
	move.l	#0,(a1)				; clear 'ID'
	move.w	(a4),4(a1)			; size
	move.l	#6,d2				; length
	move.w	#0,d3				; timeout
	moveq	#iob.smul,d0			; write
	trap	#3				; do it
	add.l	#6,a7				; restore stack
	tst.l	d0				; see if OK
	bne.s	ms.1a				; fails	
	move.w	(a4),d2				; size
	lea.l	2(a4),a1			; data
	move.w	#0,d3				; timeout
	moveq	#iob.smul,d0			; write
	trap	#3				; do it
ms.1a	move.l	(sp)+,a1			; store 
	bra	ms.1
ms.8
	move.l	(sp)+,a3
	rts

cprocs
	dc.l	0				; creq 
	dc.l	0				; cpoll
	dc.l	0				; lpoll
	dc.l	0				; sbro
	dc.l	VERS				; version
	dc.l	0				; spend

creq
	movem.l a2-a5/d2-d7,-(sp)		; 10 regs
	move.l	44(sp),a3
	bsr	getthg
	beq	c1.03	
	move.l	d0,a5
	move.l	#'SRVR',d2
	moveq	#0,d7				; check id flag = 0
	trap	#0
	bsr	CheckName
	andi.w	#$d8ff,sr
	tst.l	d0
	beq.s	c1.03
	move.l	a4,-(sp)
	move.l	#'CLNT',d2
	moveq	#1,d7				; check id flag = 1
	trap	#0
	bsr	CheckName
	andi.w	#$d8ff,sr
	move.l	(sp)+,a2
	tst.l	d0
	beq.s	c1.04

	move.l	48(sp),a1			; struct
	move.l	$10+hdr.cho(a2),a0		; Server channel
	cmp.l	#0,a0
	ble.s	c1.04
	cmp.l	#0,52(sp)
	bne.s	cr.10
	move.l	#0,(a1)
	bra.s	cr.11
cr.10
	move.l	$10+hdr.cho(a4),(a1)		; My channel for reply
cr.11 
	move.w	4(a1),d2
	add.w	#6,d2
	moveq	#-1,d3				; time out
	moveq	#iob.smul,d0			; action
	trap	#3				; now do it
	tst.l	d0
	bne.s	c1.02
	cmp.l	#0,52(sp)
	beq.s	c1.02
	moveq	#2,d2
	move.l	52(sp),a1			; buffer
	move.l	$10+hdr.chi(a4),a0		; my channel
	cmp.l	#0,a0
	ble.s	c1.04
	moveq	#iob.fmul,d0			; a read
	moveq	#-1,d3
	trap	#3
	tst.l	d0
	bne.s	c1.02
	move.l	a0,d0
	bra.s	c1.02
c1.03
	moveq	#-7,d0
	bra.s	c1.02
c1.04
	moveq	#-6,d0
c1.02
	movem.l (sp)+,a2-a5/d2-d7		; 10 regs
	rts
lpoll
	move.l	#'LSTN',d0
	bra.s	cl.0a
cpoll
	move.l	#'SRVR',d0
cl.0a
	movem.l a2-a5/d2-d7,-(sp)		; 10 regs
	move.l	d0,d2
	move.l	44(sp),a3
	bsr	getthg
	beq	c1.03	
	move.l	d0,a5
	moveq	#0,d7				; check id flag = 0
	cmpi.l	#'SRVR',d2
	beq.s	cl.0b
	moveq	#1,d7
cl.0b
	trap	#0
	bsr	CheckName
	andi.w	#$d8ff,sr
	tst.l	d0
	beq	c1.04
	move.l	$10+hdr.chi(a4),a0
	move.w	48(sp),d3
	move.l	50(sp),a1
	moveq	#6,d2
	moveq	#iob.fmul,d0
	trap	#3
	tst.l	d0
	bne.s	c2.2
	move.l	 a0,d0	
c2.2
	movem.l (sp)+,a2-a5/d2-d7		; 11 regs
	rts

spend
	move.l	#'SRVR',d0
	movem.l a2-a5/d2-d7,-(sp)		; 10 regs
	move.l	d0,d2
	move.l	44(sp),a3
	bsr	getthg
	beq	c1.03	
	move.l	d0,a5
	moveq	#0,d7				; check id flag = 0
	trap	#0
	bsr	CheckName
	andi.w	#$d8ff,sr
	tst.l	d0
	beq	c1.04
	move.l	$10+hdr.chi(a4),a0
	moveq	#0,d3
	moveq	#0,d0				; io.pend
	trap	#3
	tst.l	d0
	bne.s	pd.01
	moveq	#1,d0
	bra.s	pd.02
pd.01
	cmp.l	#-1,d0
	bne.s	pd.02
	moveq	#0,d0
pd.02
	movem.l (sp)+,a2-a5/d2-d7		; 11 regs
	rts

sbro
	movem.l a2-a5/d2-d7,-(sp)		; 10 regs
	move.l	44(sp),a3
	move.l	48(sp),a4
	bsr	SendMsg
	movem.l (sp)+,a2-a5/d2-d7		; 10 regs
	rts	

*************************************************************************
*									*
*	Procedure WRITEN converts long value in D1 to ASCII in		*
*	a buffer address via A0. D1 returns the number of ASCII		*
*	characters returned.						*
*									*
*	This procedure is lifted from the excellent book		*
*									*
*	PROGRAMMING THE M68000 by T King & B Knight			*
*	Published by Benjamin/Cummings Inc. ISBN 0-8053-5550-2		*
*************************************************************************
writen
	movem.l d0/d2-d5/a1,-(sp)	; Save regs
	clr.l	d3			; zero flag
	clr.l	d4			; Zero counter
	lea.l	pten,a1			; Powers table
	tst.l	d1			; See if +ve
	bpl.s	wrnpos			; It is
	move.b	#'-',(a0)+		; Store -ve sign
	addq.l	#1,d4			; increment counter
	bra.s	wrnnext			; enter print loop
wrnpos
	neg.l	d1			; make -ve
wrnnext
	move.l	(a1)+,d2		; next power
	beq.s	wrndone			; quit if end
	clr.b	d0			; current digit =0
wrnloop
	add.l	d2,d1			; add power of 10
	bgt.s	wrndig			; done if +ve
	addq.b	#1,d0			; increment this digit
	bra.s	wrnloop			; add again
wrndig
	sub.l	d2,d1			; correct remainder
	tst.b	d0			; is it zero
	bne.s	wrnnot0			; no
	tst.b	d3			; zero suppress required
	bne.s	wrnconv			; no
	cmpi.l	#1,d2			; is this last digit
	beq.s	wrnconv			; print if last
	bra.s	wrnnext			; don't if leading zero
wrnnot0
	moveq	#1,d3			; Show zeros required
wrnconv
	addi.b	#'0',d0			; make ascii
	move.b	d0,(a0)+		; put in buffer
	addq.l	#1,d4			; increment counter
	bra.s	wrnnext			; do next digit
wrndone
	move.l	d4,d1			; return counter
	movem.l (sp)+,d0/d2-d5/a1	; restore registers
	rts

pten	dc.l	1000000000,100000000,10000000,1000000
	dc.l	100000,10000,1000,100,10,1,0

thgname
	wstrg$	{'Client Server'}
opipe
	wstrg$	{'pipe_512'}		
ipipe
	wstrg$	{'pipe_0'}		
dummy
	dc.w	0
cmsg:
	wstrg$	{'Client-Server Manager v1.22 (c) Jonathan Hudson 1996',10}
	end
