#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include "csrvthg.h"

char _prog_name[] = "clt";

extern int InitWindow (struct QD_text *, short *);
extern void Update (int, char *, short);
long _stack = 2400;

int main (int ac, char **av)
{
    char *p;
    int n = -1;
    char *sp;
    short nc;
    short mlen;
    char *msg;
    int stdchn;
    short done = 0;
    
    sp = *(av + 1);		/* supplied sp */

    nc = *((short *) sp);	/* channels */
    sp += 2;			/* advance */

    sp += (nc << 2);		/* skip channels */
    mlen = *((short *) sp);	/* commands */

    if (mlen)			/* need this too */
    {
	if ((stdchn = InitWindow ((struct QD_text *) sp, &done)) > 0)
	{
	    msg = sp + 2;	/* service needed */

	    if ((n = UseSrvThgL (CLNT, "demo", 128)) == 0)
	    {
		short rlen;
		while (!done)
		{
                    if((p = Request ("demo", msg, mlen, &rlen)) != NULL)
                    {
		        Update (stdchn, p, rlen);
		        if (strnicmp (msg, "shuffle ", 8) == 0)
		        {
			    memcpy (msg + 8, p, rlen);
		        }
		        mt_susjb (-1, 45, NULL);
		        free (p);
		    }
		    else
		    {
		        Update (stdchn, "Srv Exit", 8);
		        done = 1;
		    }
		}
		FreeSrvThg (CLNT, "demo");
		n = 0;
	    }
	    else
	    {
                beep(5000,20);
	    }                	        
	}
    }
    return n;
}
int (*_Cstart) (int, char **) = main;
